/*
 * Copyright (C) 2002 2003 Sven Schaepe <schaepe@rz.tu-ilmenau.de>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */

#ifndef _DVBSI_H_
#define _DVBSI_H_

#include <stdio.h>

#define v_LIBDVBSI

/*********************** Global *********************************/

#define TABLESIZE(x) ((int)(sizeof(x)/sizeof(x[0])))

/*********************** Table encoding *************************/

enum encode {
  MEMCPY_kl=1,   //lnge des loops bekannt
  LOOP_kl,       //lnge des loops bekannt
  LOOP_ul,       //lnge des loops unbekannt
  DESC_kl,       //lnge des descriptors bekannt
  DESC_ul,       //lnge des descriptors unbekannt
  SUB_TAB,       //subtable
  ECM_SUB_TAB,
  EMM_SUB_TAB,
  DESC_loop_end, //descriptorloop bis zum descriptor ende
  DESC_loop_kl,  //lnge der descriptorloop bekannt
  DESC_loop_end_memcpy, //descriptorloop bis zum descriptor ende (memcpy)
  VS_loop,       //MPEG_1_only_flag==1 oder !=1
  LINKAGE,       //linkage_type==8 oder !=8
  STRING=0xa000, //lnge des string bekannt
  STRING1,       //lnge des strings unbekannt
  STRING2        //lnge des strings ist sein bitcount 
};

/*********************** standard Table *************************/

typedef struct {
  const char *name;
  unsigned int bit_count;
  int sub_table;
  enum encode encoding;
} sTABLE;

/*********************** compare Table *************************/

typedef struct {
  int desc_id;
  int d_zeile;
  int *save_in;  		/* save in */
  size_t save_in_struct_size;  	/* sizeof(current[0]) */
  int *check;
  int check_value;
} cDESC;

typedef struct { 
  int table_id;
  int t_zeile;
  int *save_in;  		/* save in */
  size_t save_in_struct_size;  	/* sizeof(current[0]) */
  int *check;
  int check_value;
} cTABLE;

extern cTABLE ctable[]; 

typedef struct {
    unsigned int value; 
    //unsigned char *string;
    unsigned char ok;
} FILTER;

typedef struct {
  void *current;
  cTABLE *encoding;
  size_t encoding_size;     	/* sizeof(encoding) */
  void *current_d;
  cDESC *desc_encoding;
  size_t desc_encoding_size;  	/* sizeof(encoding) */
  int channels;             	/* channel count */
  FILTER *filter;
} LIST;

/******************************** interface function **************************/
unsigned char get_si_stream(unsigned char *buffer,unsigned int buffer_size
					    ,LIST *todo,char all,FILE *output);

#endif
