/*
 * Copyright (C) 2002 2003 Sven Schaepe <schaepe@rz.tu-ilmenau.de>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>

#include "dvbsi.h"

unsigned int getbits(unsigned char *buffer,unsigned int bitpos,unsigned int bitcount) 
{
  unsigned int i;
  unsigned int wert=0;

    if(bitcount>32)printf("sorry bitcount too big\n");
    for(i=bitpos;i<bitcount+bitpos;i++) {
      wert=wert<<1;
      wert=wert+((buffer[i>>3]&(0x80>>(i&7)))?1:0);
    }	
    return wert;
}

int tprintf(FILE *output,unsigned int level,unsigned char *printf_format,...) 
{
  char puffer[0x1000];
  va_list arg_pointer;
  int len,i;

    for(i=0;i<level;i++) {
	fwrite("    ",1,4,output);
    }
    va_start(arg_pointer,printf_format);
    len=vsnprintf(puffer,sizeof(puffer),printf_format,arg_pointer);
    fwrite(puffer,1,len,output);
    fflush(output);
    va_end(arg_pointer);
    return 0;
}

void print_hex_dump(unsigned char *buffer, unsigned int length
			    ,unsigned int *level,FILE *output) 
{
  int i=0;

    tprintf(output,*level,"",buffer[i]);
    for(i=0;i<length;i++) {
        fprintf(output,"%x ",buffer[i]);
    }
    for(i=0;i<length;i++) {
        fprintf(output,"%c",isprint((int)buffer[i])?buffer[i]:'.');
    }
    fprintf(output,"\n");
}

/*
void debug_print(unsigned char *buffer,int length) {
int i;

  for (i=0;i<length;i++)
    printf("%x ",buffer[i]);
  printf("\n\n");
}  

void test_buffer(unsigned char *buffer,int length) {
int i;

for(i=0;i<length;i++) 
  printf("%x ",buffer[i]);
}

unsigned int fill_buffer(unsigned char *buffer,int length) {
int i;  

  for(i=0;i<length;i++) {
    buffer[i]=fgetc(stdin);
  }	
  return 0;
}


unsigned int getbuffer(cTABLE *ctable,int length) {
int table_id;
unsigned int sectionlength,level;
unsigned char section_number,last_section_number;
unsigned char buffer[length];
int i,pos=0;  

  for(i=0;i<length;i++) {
    buffer[i]=fgetc(stdin);
    if (DEBUG) {
      printf("%x ",buffer[i]);
    }
  }	
  if (DEBUG) printf("\n\n");
  table_id=getbits(buffer,0,8);
  sectionlength=getbits(buffer,12,12);
  section_number=getbits(buffer,47,8);
  last_section_number=getbits(buffer,55,8);
  level=0;
  analyse_table(ctable,buffer,&pos,table_id,sectionlength,1,&level);
  //return(last_section_number);
  return 0;
}
*/
